/*
 * SmartMatrix Library - Fonts Included for Adafruit_GFX Layers
 *
 * Copyright (c) 2020 Louis Beaudoin (Pixelmatix)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#ifndef MATRIX_ADAFRUIT_GFX_FONT_COMMON_H
#define MATRIX_ADAFRUIT_GFX_FONT_COMMON_H

#include <Adafruit_GFX.h>
#include "MatrixFontCommon.h"

// Adafruit_GFX fonts can be included only once, so include fonts used by the different GFX Layers in a central location
#include "FontGfx_apple4x6.h"
#include "FontGfx_apple5x7.h"
#include "FontGfx_apple6x10.h"
#include "FontGfx_apple8x13.h"
#include "FontGfx_gohufont6x11.h"
#include "FontGfx_gohufont6x11b.h"
#include "FontGfx_tom_thumb.h"

#endif
